<#ibiztemplate>
TARGET=PSAPPDATAENTITY
</#ibiztemplate>
<#assign deapi = item.getPSDEServiceAPI()>
<#if deapi??>
package ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.feign;

import java.util.List;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.cloud.openfeign.FeignClient;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.domain.${item.getCodeName()};
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.filter.*;

<#assign keyCNLC = "_id">

<#assign itemCodeName = item.getCodeName()>
<#assign itemCodeNameLC = itemCodeName?lower_case>
<#assign deCodeName = de.getCodeName()>
<#assign deCodeNameLC = deCodeName?lower_case>
<#assign dePKCodeNameLC = de.getKeyPSDEField().getCodeName()?lower_case>

public interface ${item.getCodeName()}FeignClient {

<#--  主实体  start -->
<#if deapi.isMajor()>
<#assign parentPath = "/" + deapi.getPSSysServiceAPI().getCodeName()?lower_case  >
<#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
<#assign parentParams = "">
<#assign parentParams2 = "">
<#assign parentParams3 = "">
<#assign idParams = "">
<#assign idParams2 = "">
<#assign idParams3 = "">
<#assign etParams = "">
<#assign etParams2 = "">
<#assign etParams3 = "">
<#assign id_etParams = "">
<#assign id_etParams2 = "">
<#assign id_etParams3 = "">
<#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams3 = etParams3 +  itemCodeNameLC + "">
<#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
<#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
<#assign fullPath = parentPath + selfPath>

    <#if deapi.getPSDEServiceAPIMethods()??>
            <#list deapi.getPSDEServiceAPIMethods() as apiMethod>
                <#assign reqMtd = apiMethod.getRequestMethod()>
                <#if apiMethod.getActionType()=='DEACTION'>
                    <#assign deaction = apiMethod.getPSDEAction()>
                    <#assign deactionName = deaction.getName()>
                    <#assign deactionCodeName = deaction.getCodeName()>
                    <#if deaction.codeName == 'Create'>

	@RequestMapping(method = RequestMethod.POST, value = "${fullPath}")
    public ${itemCodeName} ${deactionCodeName?uncap_first}(${etParams}) ;
                    <#elseif deaction.codeName == 'Update'>

	@RequestMapping(method = RequestMethod.PUT, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ${itemCodeName} ${deactionCodeName?uncap_first}(${id_etParams}) ;
                    <#elseif deaction.codeName == 'Get'>

	@RequestMapping(method = RequestMethod.GET, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ${itemCodeName} ${deactionCodeName?uncap_first}(${idParams}) ;
                    <#elseif deaction.codeName == 'Remove'>

	@RequestMapping(method = RequestMethod.DELETE, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public Boolean ${deactionCodeName?uncap_first}(${idParams}) ;
                   <#elseif deaction.codeName == 'CheckKey'>

	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public Boolean ${deactionCodeName?uncap_first}(${etParams}) ;
                    <#else>

	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/${deactionCodeName?lower_case}")
    public ${itemCodeName} ${deactionCodeName?uncap_first}(${id_etParams}) ;
                    </#if>
                <#elseif apiMethod.getActionType()=='FETCH'>
                    <#assign deds = apiMethod.getPSDEDataSet()>

    @RequestMapping(method= RequestMethod.${reqMtd} , value="${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>")
	public Page<${itemCodeName}> fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>(<#if parentParams != "">${parentParams} , </#if>${itemCodeName}SearchContext searchContext) ;
                </#if>
            </#list>
        </#if>
</#if>
<#--  主实体  end -->


<#--  关系接口  start  -->
<#if deapi.getPSDEServiceAPIRSPathCount() gt 0>
  <#list 0..1000 as x>
    <#if x gte deapi.getPSDEServiceAPIRSPathCount()>
      <#break>
    <#else>
      <#list deapi.getPSDEServiceAPIRSPath(x) as rs>
        <#assign parentPath = "/" + deapi.getPSSysServiceAPI().getCodeName()?lower_case  >
        <#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
        <#assign parentParams = "">
        <#assign byParams = "By">
        <#assign parentParams2 = "">
        <#assign parentParams3 = "">
        <#assign idParams = "">
        <#assign idParams2 = "">
        <#assign idParams3 = "">
        <#assign etParams = "">
        <#assign etParams2 = "">
        <#assign etParams3 = "">
        <#assign id_etParams = "">
        <#assign id_etParams2 = "">
        <#assign id_etParams3 = "">
        <#assign rsMainDEServiceAPI = rs.getMajorPSDEServiceAPI()>
        <#assign rsMainDe = rsMainDEServiceAPI.getPSDataEntity()>
        <#assign rsMainDeCN = rsMainDe.codeName >
        <#assign rsMainDeCNLC = rsMainDeCN?lower_case >
        <#assign rsMainDePKCN = rsMainDe.getKeyPSDEField().codeName >
        <#assign rsMainDePKCNLC = rsMainDePKCN?lower_case >
        <#assign rsMainDePKDataType = rsMainDe.getKeyPSDEField().getStdDataType() >
        <#assign parentPath += "/" + srfpluralize(rsMainDEServiceAPI.codeName)?lower_case + "/{" + rsMainDeCNLC + keyCNLC + "}" >
        <#if x != 0>
          <#assign parentParams += ", ">
        </#if>
        <#assign parentParams += "@PathVariable(\"" + rsMainDeCNLC + keyCNLC + "\") " + srfjavatype(rsMainDePKDataType) +  " " + rsMainDeCNLC + keyCNLC >
        <#assign byParams += rsMainDeCN >
        <#assign parentParams2 += "" + srfjavatype(rsMainDePKDataType)+" " + rsMainDeCNLC + keyCNLC >
        <#assign parentParams3 += "" + rsMainDeCNLC + keyCNLC >
        <#if parentParams != "" >
            <#assign idParams = parentParams + ", ">
            <#assign idParams2 = parentParams2 + ", ">
            <#assign idParams3 = parentParams3 + ", ">
            <#assign etParams = parentParams + ", ">
            <#assign etParams2 = parentParams2 + ", ">
            <#assign etParams3 = parentParams3 + ", ">
            <#assign id_etParams = parentParams + ", ">
            <#assign id_etParams2 = parentParams2 + ", ">
            <#assign id_etParams3 = parentParams3 + ", ">
        </#if>
        <#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
        <#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
        <#assign etParams3 = etParams3 +  itemCodeNameLC + "">
        <#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
        <#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
        <#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
        <#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
        <#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
        <#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
        <#assign fullPath = parentPath + selfPath>

<#if deapi.getPSDEServiceAPIMethods()??>
            <#list deapi.getPSDEServiceAPIMethods() as apiMethod>
                <#assign reqMtd = apiMethod.getRequestMethod()>
                <#if apiMethod.getActionType()=='DEACTION'>
                    <#assign deaction = apiMethod.getPSDEAction()>
                    <#assign deactionName = deaction.getName()>
                    <#assign deactionCodeName = deaction.getCodeName()>
                    <#if deaction.codeName == 'Create'>

	@RequestMapping(method = RequestMethod.POST, value = "${fullPath}")
    public ${itemCodeName} ${deactionCodeName?uncap_first}${byParams}(${etParams}) ;
                    <#elseif deaction.codeName == 'Update'>

	@RequestMapping(method = RequestMethod.PUT, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ${itemCodeName} ${deactionCodeName?uncap_first}${byParams}(${id_etParams}) ;
                    <#elseif deaction.codeName == 'Get'>

	@RequestMapping(method = RequestMethod.GET, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ${itemCodeName} ${deactionCodeName?uncap_first}${byParams}(${idParams}) ;
                    <#elseif deaction.codeName == 'Remove'>

	@RequestMapping(method = RequestMethod.DELETE, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public Boolean ${deactionCodeName?uncap_first}${byParams}(${idParams}) ;
                   <#elseif deaction.codeName == 'CheckKey'>

	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public Boolean ${deactionCodeName?uncap_first}${byParams}(${etParams}) ;
                    <#else>

	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/${deactionCodeName?lower_case}")
    public ${itemCodeName} ${deactionCodeName?uncap_first}${byParams}(${id_etParams}) ;
                    </#if>
                <#elseif apiMethod.getActionType()=='FETCH'>
                    <#assign deds = apiMethod.getPSDEDataSet()>

    @RequestMapping(method= RequestMethod.${reqMtd} , value="${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>")
	public Page<${itemCodeName}> fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>${byParams}(<#if parentParams != "">${parentParams} , </#if>${itemCodeName}SearchContext searchContext) ;
                </#if>
            </#list>
        </#if>

      </#list>
    </#if>
  </#list>
</#if>
<#--  关系接口  end  -->
}
</#if>