<#ibiztemplate>
TARGET=PSAPPDATAENTITY
</#ibiztemplate>
<#assign isCurWFDE = false>
<#if app.getAppMode()?? && app.getAppMode() == "WFAPP" && app.getAllPSAppWFs()??>
    <#list app.getAllPSAppWFs() as appwf>
        <#if appwf.getPSWorkflow().getWFProxyMode() == 3 && appwf.getPSWorkflow().getPSWFDEs()??>
            <#list appwf.getPSWorkflow().getPSWFDEs() as wfde>
                <#if wfde.getWFProxyMode() == 2 && wfde.getCodeName() == de.getCodeName()>
                    <#assign isCurWFDE = true>
                    <#break>
                </#if>
            </#list>
            <#if isCurWFDE>
                <#break>
            </#if>
        </#if>
    </#list>
</#if>
<#assign keyCNLC = "_id">
<#assign deapi = item.getPSDEServiceAPI()>
<#assign itemCodeName = item.getCodeName()>
<#assign itemCodeNameLC = itemCodeName?lower_case>
<#assign itemSysApiCodeName = deapi.getPSSysServiceAPI().getCodeName()>
<#assign itemSysApiCodeNameLC = deapi.getPSSysServiceAPI().getCodeName()?lower_case>

package ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.service;

import java.util.ArrayList;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.openfeign.ribbon.LoadBalancerFeignClient;
import org.springframework.stereotype.Service;

import feign.Client;
import feign.Contract;
import feign.Feign;
import feign.codec.Decoder;
import feign.codec.Encoder;

import com.alibaba.fastjson.JSONObject;

import org.springframework.util.DigestUtils;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import ${pub.getPKGCodeName()}.util.feign.suport.SearchContextFeignEncode;
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.domain.${item.getCodeName()};
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.filter.*;
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.feign.${item.getCodeName()}FeignClient;
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${app.getPKGCodeName()}Application.${itemSysApiCodeName}ClientProperties;
import ${pub.getPKGCodeName()}.util.feign.FeignRequestInterceptor;
<#if isCurWFDE>
import ${pub.getPKGCodeName()}.util.config.UniWFClientProperties;
import ${pub.getPKGCodeName()}.util.config.WFActivitiEngineClientProperties;
import ${pub.getPKGCodeName()}.util.feign.UniWFFeignClient;
import ${pub.getPKGCodeName()}.util.feign.WFEngineFeignClient;
import ${pub.getPKGCodeName()}.util.config.SysInfoProperties;
import ${pub.getPKGCodeName()}.util.domain.*;
</#if>

@Service
public class ${item.getCodeName()}Service {

    ${item.getCodeName()}FeignClient client;
<#if isCurWFDE>
    UniWFFeignClient uniWFFeignClient;
    WFEngineFeignClient wfActivitiEngineFeignClient;

    @Autowired
    SysInfoProperties sysInfoProperties;
</#if>

    @Autowired
    public ${item.getCodeName()}Service(Decoder decoder, Encoder encoder, Client client, Contract contract, FeignRequestInterceptor feignRequestInterceptor,
                                    ${itemSysApiCodeName}ClientProperties ${itemSysApiCodeNameLC}ClientProperties<#if isCurWFDE>, UniWFClientProperties uniWFClientProperties, WFActivitiEngineClientProperties wfActivitiEngineClientProperties</#if>) {
        if (${itemSysApiCodeNameLC}ClientProperties.getServiceId()!=null) {
    		Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(new SearchContextFeignEncode(encoder))
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.client = nameBuilder.target(${item.getCodeName()}FeignClient.class,"http://" + ${itemSysApiCodeNameLC}ClientProperties.getServiceId() + "/") ;
		} else if (${itemSysApiCodeNameLC}ClientProperties.getServiceUrl()!=null) {
			if (client instanceof LoadBalancerFeignClient) {
				client = ((LoadBalancerFeignClient) client).getDelegate();
			}
			Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(new SearchContextFeignEncode(encoder))
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.client = nameBuilder.target(${item.getCodeName()}FeignClient.class, "http://" + ${itemSysApiCodeNameLC}ClientProperties.getServiceUrl() + "/") ;
		}
<#if isCurWFDE>
		if (uniWFClientProperties.getServiceId()!=null) {
    		Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(encoder)
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.uniWFFeignClient = nameBuilder.target(UniWFFeignClient.class,"http://" + uniWFClientProperties.getServiceId() + "/") ;
		} else if (uniWFClientProperties.getServiceUrl()!=null) {
			if (client instanceof LoadBalancerFeignClient) {
				client = ((LoadBalancerFeignClient) client).getDelegate();
			}
			Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(encoder)
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.uniWFFeignClient = nameBuilder.target(UniWFFeignClient.class, "http://" + uniWFClientProperties.getServiceUrl() + "/") ;
		}
		if (wfActivitiEngineClientProperties.getServiceId()!=null) {
    		Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(encoder)
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.wfActivitiEngineFeignClient = nameBuilder.target(WFEngineFeignClient.class,"http://" + wfActivitiEngineClientProperties.getServiceId() + "/") ;
		} else if (wfActivitiEngineClientProperties.getServiceUrl()!=null) {
			if (client instanceof LoadBalancerFeignClient) {
				client = ((LoadBalancerFeignClient) client).getDelegate();
			}
			Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(encoder)
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.wfActivitiEngineFeignClient = nameBuilder.target(WFEngineFeignClient.class, "http://" + wfActivitiEngineClientProperties.getServiceUrl() + "/") ;
		}
</#if>
    }

<#--  主实体  start -->
<#if item.isMajor()>
<#assign parentPath = ""  >
<#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
<#assign parentParams = "">
<#assign parentParams2 = "">
<#assign parentParams3 = "">
<#assign idParams = "">
<#assign idParams2 = "">
<#assign idParams3 = "">
<#assign etParams = "">
<#assign etParams2 = "">
<#assign etParams3 = "">
<#assign id_etParams = "">
<#assign id_etParams2 = "">
<#assign id_etParams3 = "">
<#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams3 = etParams3 +  itemCodeNameLC + "">
<#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
<#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
<#assign fullPath = parentPath + selfPath>
<#if item.getAllPSAppDEMethods()??>
    <#list item.getAllPSAppDEMethods() as appMethod>
    <#if appMethod.getPSDEServiceAPIMethod()??>
        <#if appMethod.getMethodType()=='DEACTION'>
            <#assign appMethodCodeName = appMethod.getCodeName()>
            <#assign deaction = appMethod.getPSDEServiceAPIMethod().getPSDEAction()>
            <#assign deactionName = deaction.getName()>
            <#assign deactionCodeName = deaction.getCodeName()>
            <#if deaction.codeName == 'Create'>
	public ${itemCodeName} ${appMethodCodeName?uncap_first}(${etParams2}) {
        return client.${deactionCodeName?uncap_first}(${etParams3});
    }

            <#elseif deaction.codeName == 'Update'>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}(${id_etParams2}) {
        return client.${deactionCodeName?uncap_first}(${id_etParams3});
    }

            <#elseif deaction.codeName == 'Get'>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}(${idParams2}) {
        return client.${deactionCodeName?uncap_first}(${idParams3});
    }

            <#elseif deaction.codeName == 'Remove'>
    public boolean ${appMethodCodeName?uncap_first}(${idParams2}) {
        return client.${deactionCodeName?uncap_first}(${idParams3});
    }

           <#elseif deaction.codeName == 'CheckKey'>
    public boolean ${appMethodCodeName?uncap_first}(${etParams2}) {
        return client.${deactionCodeName?uncap_first}(${etParams3});
    }

            <#else>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}(${id_etParams2}) {
        return client.${deactionCodeName?uncap_first}(${id_etParams3});
    }

            </#if>
        <#elseif appMethod.getMethodType()=='FETCH'>
        <#assign deds = appMethod.getPSDEDataSet()>
	public Page<${itemCodeName}> fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>(<#if parentParams != "">${parentParams2} , </#if>${itemCodeName}SearchContext searchContext) {
        return client.fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>(<#if parentParams != "">${parentParams3} , </#if>searchContext);
    }

        </#if>
    </#if>
    </#list>
</#if>
</#if>
<#--  主实体  end -->

<#--  关系接口  start  -->
<#if item.getPSAppDERSPathCount() gt 0>
  <#list 0..1000 as x>
    <#if x gte item.getPSAppDERSPathCount()>
      <#break>
    <#else>
      <#list item.getPSAppDERSPath(x) as rs>
        <#assign parentPath = ""  >
<#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
<#assign parentParams = "">
<#assign byParams = "By">
<#assign parentParams2 = "">
<#assign parentParams3 = "">
<#assign idParams = "">
<#assign idParams2 = "">
<#assign idParams3 = "">
<#assign etParams = "">
<#assign etParams2 = "">
<#assign etParams3 = "">
<#assign id_etParams = "">
<#assign id_etParams2 = "">
<#assign id_etParams3 = "">
<#assign rsMainAppDe = rs.getMajorPSAppDataEntity()>
                <#assign rsMainDe = rsMainAppDe.getPSDataEntity()>
                <#assign rsMainAppDeCN = rsMainAppDe.codeName >
                <#assign rsMainAppDeCNLC = rsMainAppDeCN?lower_case >
                <#assign rsMainDePKCN = rsMainDe.getKeyPSDEField().codeName >
                <#assign rsMainDePKCNLC = rsMainDePKCN?lower_case >
                <#assign rsMainDePKDataType = rsMainDe.getKeyPSDEField().stdDataType >
                <#assign parentPath += "/" + srfpluralize(rsMainAppDeCNLC)?lower_case + "/{" + rsMainAppDeCNLC + keyCNLC + "}" >
                <#if x != 0>
                    <#assign parentParams += ", ">
                </#if>
                <#assign parentParams += "@PathVariable(\"" + rsMainAppDeCNLC + keyCNLC + "\") " + srfjavatype(rsMainDePKDataType) + " " + rsMainAppDeCNLC + keyCNLC >
                <#assign byParams += rsMainAppDeCN >
                <#assign parentParams2 += "" + srfjavatype(rsMainDePKDataType) + " " + rsMainAppDeCNLC + keyCNLC >
                <#assign parentParams3 += "" + rsMainAppDeCNLC + keyCNLC >
<#if parentParams != "" >
    <#assign idParams = parentParams + ", ">
    <#assign idParams2 = parentParams2 + ", ">
    <#assign idParams3 = parentParams3 + ", ">
    <#assign etParams = parentParams + ", ">
    <#assign etParams2 = parentParams2 + ", ">
    <#assign etParams3 = parentParams3 + ", ">
    <#assign id_etParams = parentParams + ", ">
    <#assign id_etParams2 = parentParams2 + ", ">
    <#assign id_etParams3 = parentParams3 + ", ">
</#if>
<#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams3 = etParams3 +  itemCodeNameLC + "">
<#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
<#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
<#assign fullPath = parentPath + selfPath>

<#if item.getAllPSAppDEMethods()??>
    <#list item.getAllPSAppDEMethods() as appMethod>
    <#if appMethod.getPSDEServiceAPIMethod()??>
        <#if appMethod.getMethodType()=='DEACTION'>
            <#assign appMethodCodeName = appMethod.getCodeName()>
            <#assign deaction = appMethod.getPSDEAction()>
            <#assign deactionName = deaction.getName()>
            <#assign deactionCodeName = deaction.getCodeName()>
            <#if deaction.codeName == 'Create'>
	public ${itemCodeName} ${appMethodCodeName?uncap_first}${byParams}(${etParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${etParams3});
    }

            <#elseif deaction.codeName == 'Update'>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}${byParams}(${id_etParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${id_etParams3});
    }

            <#elseif deaction.codeName == 'Get'>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}${byParams}(${idParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${idParams3});
    }

            <#elseif deaction.codeName == 'Remove'>
    public boolean ${appMethodCodeName?uncap_first}${byParams}(${idParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${idParams3});
    }

           <#elseif deaction.codeName == 'CheckKey'>
    public boolean ${appMethodCodeName?uncap_first}${byParams}(${etParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${etParams3});
    }

            <#else>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}${byParams}(${id_etParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${id_etParams3});
    }

            </#if>
        <#elseif appMethod.getMethodType()=='FETCH'>
        <#assign deds = appMethod.getPSDEDataSet()>
	public Page<${itemCodeName}> fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>${byParams}(<#if parentParams != "">${parentParams2} , </#if>${itemCodeName}SearchContext searchContext) {
        return client.fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>${byParams}(<#if parentParams != "">${parentParams3} , </#if>searchContext);
    }

        </#if>
    </#if>
    </#list>
</#if>

      </#list>
    </#if>
  </#list>
</#if>
<#--  关系接口  end  -->

<#if isCurWFDE>
    <#assign itemPKParam = itemCodeNameLC + keyCNLC>
    <#assign wfFuncParams = srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemPKParam + ", JSONObject data">
    /** 工作流行为 **/

    /**
     * 开始流程【WFStart】
     */
    public boolean wfStart(${wfFuncParams}) {
        if (data == null || data.getJSONObject("wfdata") == null) {
            return false;
        }

        // 流程数据
        JSONObject itemJo = data.getJSONObject("wfdata");

        ${itemCodeName} ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);

        // 统一工作流申请实例
        WFInstance wfinstance = new WFInstance();
        <#assign wf = item.getPSAppWF().getPSWorkflow()>
        wfinstance.setBsdata(${itemCodeNameLC}.get${de.getDefaultPSDEWF().getProxyDataPSDEField().getCodeName()?cap_first}());
        wfinstance.setBswfdata(${itemCodeNameLC}${keyCNLC});
        wfinstance.setPsworkflowid("${wf.getId()}");
        <#if item.getPSAppWF().getPSAppWFVers()??>
            <#list item.getPSAppWF().getPSAppWFVers() as wfver>
        wfinstance.setPswfversionid("${wfver.getId()}");
            <#break>
            </#list>
        </#if>
        wfinstance.setWorkflowid(sysInfoProperties.getDomainid());
        wfinstance.setPssystemid(sysInfoProperties.getSystemid());
        WFInstanceDTO wfinstancedto = uniWFFeignClient.createWFInstance(wfinstance);
        ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}(wfinstancedto.getWfinstanceid());

        // 引擎创建实例

        // 获取工作流引擎标识
        PSWFVersionDTO wfVer = uniWFFeignClient.getPSWFVersion(wfinstancedto.getPswfversionid());

        JSONObject params = new JSONObject();
        // 模拟用户
        params.put("userid", "system");
        // 工作流引擎工作流标识
        params.put("deployid", wfVer.getWfenginedeployid());
        // 业务数据
        params.put("variables", data.getJSONObject("bsdata"));
        // 实例数据
        params.put("wfinstance", wfinstancedto);
    <#if de.getDefaultPSDEWF().getEntityWFState()??>
        // 流程中状态值
        params.put("workingstate", "${de.getDefaultPSDEWF().getEntityWFState()}");
    </#if>

        JSONObject rstObj = wfActivitiEngineFeignClient.wfStart(params);
        if (rstObj.getInteger("rst") == 0) {
            return false;
        }
    <#if de.getDefaultPSDEWF().getEntityWFState()??>
        ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFStatePSDEField().getCodeName()?cap_first}("${de.getDefaultPSDEWF().getEntityWFState()}");
    </#if>
        // 当前步骤
        ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFStepPSDEField().getCodeName()?cap_first}(rstObj.getString("curstep"));
        return true;
    }

    /**
     * 流程处理【WFSubmit】
     */
    public boolean wfSubmit(${wfFuncParams}) {
        if (data == null ||
            data.getJSONObject("wfdata") == null || data.getJSONObject("opdata") == null ||
            data.getJSONObject("opdata").getString("srfwfiatag") == null || data.getJSONObject("opdata").getString("srfwfstep") == null) {
            return false;
        }

        // 应用工作流版本
        PSWFVersion pswfversion = new PSWFVersion();
        <#assign wf = item.getPSAppWF().getPSWorkflow()>
        <#if item.getPSAppWF().getPSAppWFVers()??>
            <#list item.getPSAppWF().getPSAppWFVers() as wfver>
        pswfversion.setPswfversionid("${wfver.getId()}");
            <#break>
            </#list>
        </#if>
        pswfversion.setWorkflowid(sysInfoProperties.getDomainid());
        pswfversion.setPssystemid(sysInfoProperties.getSystemid());

        // 流程数据
        JSONObject itemJo = data.getJSONObject("wfdata");

        ${itemCodeName} ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);

        JSONObject params = new JSONObject();
        // 模拟用户
        params.put("userid", "system");
        // 业务数据
        params.put("variables", data.getJSONObject("bsdata"));
        // 工作列表
        String wfworklistid = data.getString("worklistid");
        if (wfworklistid != null) {
            params.put("wfworklist", uniWFFeignClient.getWFWorkList(wfworklistid));
        } else {
            JSONObject condition = new JSONObject();
            JSONObject pageable  = new JSONObject();
            pageable.put("pagenumber", 1);
            pageable.put("pagesize", 1);
            condition.put("pageable", pageable);
            condition.put("n_wfuserid_eq", "system");
            condition.put("n_wfinstanceid_eq", ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}());
            Page<WFWorkListDTO> wfworklists = uniWFFeignClient.getWFWorkListByCondition(condition);
            if (wfworklists == null || wfworklists.getContent().size() == 0) {
                return false;
            }
            params.put("wfworklist", wfworklists.getContent().get(0));
        }
        // 当前步骤
        params.put("curstep", data.getJSONObject("opdata").getString("srfwfstep"));
        // 操作行为
        params.put("action", sysInfoProperties.getDomainid() + "-" + sysInfoProperties.getSystemid() + "-" + pswfversion.getPswfversionid() + "-" + data.getJSONObject("opdata").getString("srfwfiatag"));

        JSONObject rstObj = wfActivitiEngineFeignClient.wfSubmit(params);
        if (rstObj.getInteger("rst") == 0) {
            return false;
        }
        // 当前步骤
        ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFStepPSDEField().getCodeName()?cap_first}(rstObj.getString("curStep"));
        return true;
    }

    /**
     * 流程结束【WFClose】
     */
    public boolean wfClose(${wfFuncParams}) {
        if (data == null ||
            data.getJSONObject("wfdata") == null || data.getJSONObject("opdata") == null ||
            data.getJSONObject("opdata").getString("srfwfiatag") == null || data.getJSONObject("opdata").getString("srfwfstep") == null) {
            return false;
        }

        // 应用工作流版本
        PSWFVersion pswfversion = new PSWFVersion();
        <#assign wf = item.getPSAppWF().getPSWorkflow()>
        <#if item.getPSAppWF().getPSAppWFVers()??>
            <#list item.getPSAppWF().getPSAppWFVers() as wfver>
        pswfversion.setPswfversionid("${wfver.getId()}");
            <#break>
            </#list>
        </#if>
        pswfversion.setWorkflowid(sysInfoProperties.getDomainid());
        pswfversion.setPssystemid(sysInfoProperties.getSystemid());

        // 流程数据
        JSONObject itemJo = data.getJSONObject("wfdata");

        ${itemCodeName} ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);

        JSONObject params = new JSONObject();
        // 模拟用户
        params.put("userid", "system");
        // 业务数据
        params.put("variables", data.getJSONObject("bsdata"));
        // 工作列表
        String wfworklistid = data.getString("worklistid");
        if (wfworklistid != null) {
            params.put("wfworklist", uniWFFeignClient.getWFWorkList(wfworklistid));
        } else {
            JSONObject condition = new JSONObject();
            JSONObject pageable  = new JSONObject();
            pageable.put("pagenumber", 1);
            pageable.put("pagesize", 1);
            condition.put("pageable", pageable);
            condition.put("n_wfuserid_eq", "system");
            condition.put("n_wfinstanceid_eq", ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}());
            Page<WFWorkListDTO> wfworklists = uniWFFeignClient.getWFWorkListByCondition(condition);
            if (wfworklists == null || wfworklists.getContent().size() == 0) {
                return false;
            }
            params.put("wfworklist", wfworklists.getContent().get(0));
        }
        // 当前步骤
        params.put("curstep", data.getJSONObject("opdata").getString("srfwfstep"));
        // 操作行为
        params.put("action", sysInfoProperties.getDomainid() + "-" + sysInfoProperties.getSystemid() + "-" + pswfversion.getPswfversionid() + "-" + data.getJSONObject("opdata").getString("srfwfiatag"));
        // 实例对象
        WFInstanceDTO wfinstance = uniWFFeignClient.getWFInstance(${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}());
        params.put("wfinstance", wfinstance);

        JSONObject rstObj = wfActivitiEngineFeignClient.wfClose(params);
        if (rstObj.getInteger("rst") == 0) {
            return false;
        }
        // 当前步骤
        ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFStepPSDEField().getCodeName()?cap_first}("");
        return true;
    }

    /**
     * 流程跳转【WFGoto】
     */
    public boolean wfGoto(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程重启【WFRestart】
     */
    public boolean wfRestart(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程撤回【WFRollback】
     */
    public boolean wfRollback(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程退回【WFSendBack】
     */
    public boolean wfSendBack(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程重新分配【WFReassign】
     */
    public boolean wfReassign(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程标记已读【WFMarkRead】
     */
    public boolean wfMarkRead(${wfFuncParams}) {
        // 待实现
        return true;
    }
</#if>
}
